// Clears the sidarext_clearResource
function sidarext_clearResource()
{
    window.opener.sidarext_resourceDescription = null;
    window.opener.sidarext_resourceKey         = null;
    window.opener.sidarext_resourceURL         = null;
}

// Initializes the Resource dialog box
function sidarext_initializeResource()
{
    const stringBundle = document.getElementById("sidarext-string-bundle");

    // If the first argument equals add
    if(window.arguments[0] == "add")
    {
        title = stringBundle.getString("sidarext_addResourceTitle");
    }
    else
    {
        title = stringBundle.getString("sidarext_editResourceTitle");

        document.getElementById("sidarext.resource.description").value = window.arguments[1];
        document.getElementById("sidarext.resource.key").value         = window.arguments[3];
        document.getElementById("sidarext.resource.url").value         = window.arguments[2];
    }
}

// Saves the Resource
function sidarext_saveResource()
{
    const description  = document.getElementById("sidarext.resource.description").value.trim();
    const key          = document.getElementById("sidarext.resource.key").value.trim();
    const stringBundle = document.getElementById("sidarext-string-bundle");
    const url          = document.getElementById("sidarext.resource.url").value.trim();

    var errors = "";

    // If the description is empty
    if(!description)
    {
        errors += stringBundle.getString("sidarext_emptyDescription") + "\n";
    }

    // If the URL is empty
    if(!url)
    {
        errors += stringBundle.getString("sidarext_emptyURL") + "\n";
    }

    // If there are errors
    if(errors)
    {
        alert(errors.trim());
        return false;
    }
    else
    {
        window.opener.sidarext_resourceDescription = description;
        window.opener.sidarext_resourceKey         = key;
        window.opener.sidarext_resourceURL         = url;

        return true;
    }
}
