var sidarext_optionsDataBoolean  = new Array();
var sidarext_optionsDataInteger  = new Array();
var sidarext_optionsDataString   = new Array();
var sidarext_blogDescription   = null;
var sidarext_blogKey       = null;
var sidarext_blogURL       = null;
var sidarext_docDescription    = null;
var sidarext_docKey        = null;
var sidarext_docURL        = null;
var sidarext_listDescription   = null;
var sidarext_listKey       = null;
var sidarext_listURL       = null;
var sidarext_resourceDescription = null;
var sidarext_resourceKey     = null;
var sidarext_resourceURL     = null;
var sidarext_toolDescription   = null;
var sidarext_toolKey       = null;
var sidarext_toolURL       = null;


// Adds a tool
function sidarext_addTool()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const toolBox    = pageDocument.getElementById("sidarext-listbox");

  window.openDialog("chrome://sidarext/content/options/dialogs/tool.xul", "sidarext-tool-dialog", "centerscreen,chrome,modal", "add");

  // If the description and URL are set
  if(sidarext_toolDescription && sidarext_toolURL)
  {
    var listCell = pageDocument.createElement("listcell");
    var listItem = pageDocument.createElement("listitem");

    listCell.setAttribute("label", sidarext_toolDescription);
    listItem.appendChild(listCell);

    listCell = pageDocument.createElement("listcell");
    listCell.setAttribute("label", sidarext_toolURL);
    listCell.setAttribute("crop", "end");
    listItem.appendChild(listCell);

    listCell = pageDocument.createElement("listcell");
    listCell.setAttribute("label", sidarext_toolKey);
    listItem.appendChild(listCell);

    toolBox.selectItem(toolBox.appendChild(listItem));
  }
}

// Deletes a tool
function sidarext_deleteTool()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const stringBundle = document.getElementById("sidarext-string-bundle");
  const toolBox    = pageDocument.getElementById("sidarext-listbox");
  const selectedItem = toolBox.selectedItem;

  // If an item is selected and the deletion is confirmed
  if(selectedItem && confirm(stringBundle.getString("sidarext_toolDeleteConfirmation")))
  {
    toolBox.removeChild(selectedItem);
  }
}

// Edits a tool
function sidarext_editTool()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const toolBox    = pageDocument.getElementById("sidarext-listbox");
  const selectedItem = toolBox.selectedItem;

  // If an option is selected
  if(selectedItem)
  {
    window.openDialog("chrome://sidarext/content/options/dialogs/tool.xul", "sidarext-tool-dialog", "centerscreen,chrome,modal", "edit", selectedItem.childNodes[0].getAttribute("label"), selectedItem.childNodes[1].getAttribute("label"), selectedItem.childNodes[2].getAttribute("label"));

    // If the description and url are set
    if(sidarext_toolDescription && sidarext_toolURL)
    {
      var listCell = pageDocument.createElement("listcell");

      sidarext_removeAllChildNodes(selectedItem);

      listCell.setAttribute("label", sidarext_toolDescription);
      selectedItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", sidarext_toolURL);
      listCell.setAttribute("crop", "end");
      selectedItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", sidarext_toolKey);
      selectedItem.appendChild(listCell);
    }
  }
}


// Adds a blog
function sidarext_addBlog()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const blogBox    = pageDocument.getElementById("sidarext-listbox");

  window.openDialog("chrome://sidarext/content/options/dialogs/blog.xul", "sidarext-blog-dialog", "centerscreen,chrome,modal", "add");

  // If the description and URL are set
  if(sidarext_blogDescription && sidarext_blogURL)
  {
    var listCell = pageDocument.createElement("listcell");
    var listItem = pageDocument.createElement("listitem");

    listCell.setAttribute("label", sidarext_blogDescription);
    listItem.appendChild(listCell);

    listCell = pageDocument.createElement("listcell");
    listCell.setAttribute("label", sidarext_blogURL);
    listCell.setAttribute("crop", "end");
    listItem.appendChild(listCell);

    listCell = pageDocument.createElement("listcell");
    listCell.setAttribute("label", sidarext_blogKey);
    listItem.appendChild(listCell);

    blogBox.selectItem(blogBox.appendChild(listItem));
  }
}

// Deletes a blog
function sidarext_deleteBlog()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const stringBundle = document.getElementById("sidarext-string-bundle");
  const blogBox    = pageDocument.getElementById("sidarext-listbox");
  const selectedItem = blogBox.selectedItem;

  // If an item is selected and the deletion is confirmed
  if(selectedItem && confirm(stringBundle.getString("sidarext_blogDeleteConfirmation")))
  {
    blogBox.removeChild(selectedItem);
  }
}

// Edits a blog
function sidarext_editBlog()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const blogBox    = pageDocument.getElementById("sidarext-listbox");
  const selectedItem = blogBox.selectedItem;

  // If an option is selected
  if(selectedItem)
  {
    window.openDialog("chrome://sidarext/content/options/dialogs/blog.xul", "sidarext-blog-dialog", "centerscreen,chrome,modal", "edit", selectedItem.childNodes[0].getAttribute("label"), selectedItem.childNodes[1].getAttribute("label"), selectedItem.childNodes[2].getAttribute("label"));

    // If the description and url are set
    if(sidarext_blogDescription && sidarext_blogURL)
    {
      var listCell = pageDocument.createElement("listcell");

      sidarext_removeAllChildNodes(selectedItem);

      listCell.setAttribute("label", sidarext_blogDescription);
      selectedItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", sidarext_blogURL);
      listCell.setAttribute("crop", "end");
      selectedItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", sidarext_blogKey);
      selectedItem.appendChild(listCell);
    }
  }
}


// Adds a doc
function sidarext_addDoc()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const docBox    = pageDocument.getElementById("sidarext-listbox");

  window.openDialog("chrome://sidarext/content/options/dialogs/doc.xul", "sidarext-doc-dialog", "centerscreen,chrome,modal", "add");

  // If the description and URL are set
  if(sidarext_docDescription && sidarext_docURL)
  {
    var listCell = pageDocument.createElement("listcell");
    var listItem = pageDocument.createElement("listitem");

    listCell.setAttribute("label", sidarext_docDescription);
    listItem.appendChild(listCell);

    listCell = pageDocument.createElement("listcell");
    listCell.setAttribute("label", sidarext_docURL);
    listCell.setAttribute("crop", "end");
    listItem.appendChild(listCell);

    listCell = pageDocument.createElement("listcell");
    listCell.setAttribute("label", sidarext_docKey);
    listItem.appendChild(listCell);

    docBox.selectItem(docBox.appendChild(listItem));
  }
}

// Deletes a doc
function sidarext_deleteDoc()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const stringBundle = document.getElementById("sidarext-string-bundle");
  const docBox    = pageDocument.getElementById("sidarext-listbox");
  const selectedItem = docBox.selectedItem;

  // If an item is selected and the deletion is confirmed
  if(selectedItem && confirm(stringBundle.getString("sidarext_docDeleteConfirmation")))
  {
    docBox.removeChild(selectedItem);
  }
}

// Edits a doc
function sidarext_editDoc()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const docBox    = pageDocument.getElementById("sidarext-listbox");
  const selectedItem = docBox.selectedItem;

  // If an option is selected
  if(selectedItem)
  {
    window.openDialog("chrome://sidarext/content/options/dialogs/doc.xul", "sidarext-doc-dialog", "centerscreen,chrome,modal", "edit", selectedItem.childNodes[0].getAttribute("label"), selectedItem.childNodes[1].getAttribute("label"), selectedItem.childNodes[2].getAttribute("label"));

    // If the description and url are set
    if(sidarext_docDescription && sidarext_docURL)
    {
      var listCell = pageDocument.createElement("listcell");

      sidarext_removeAllChildNodes(selectedItem);

      listCell.setAttribute("label", sidarext_docDescription);
      selectedItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", sidarext_docURL);
      listCell.setAttribute("crop", "end");
      selectedItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", sidarext_docKey);
      selectedItem.appendChild(listCell);
    }
  }
}

// Adds a list
function sidarext_addList()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const listBox    = pageDocument.getElementById("sidarext-listbox");

  window.openDialog("chrome://sidarext/content/options/dialogs/list.xul", "sidarext-list-dialog", "centerscreen,chrome,modal", "add");

  // If the description and URL are set
  if(sidarext_listDescription && sidarext_listURL)
  {
    var listCell = pageDocument.createElement("listcell");
    var listItem = pageDocument.createElement("listitem");

    listCell.setAttribute("label", sidarext_listDescription);
    listItem.appendChild(listCell);

    listCell = pageDocument.createElement("listcell");
    listCell.setAttribute("label", sidarext_listURL);
    listCell.setAttribute("crop", "end");
    listItem.appendChild(listCell);

    listCell = pageDocument.createElement("listcell");
    listCell.setAttribute("label", sidarext_listKey);
    listItem.appendChild(listCell);

    listBox.selectItem(listBox.appendChild(listItem));
  }
}

// Deletes a list
function sidarext_deleteList()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const stringBundle = document.getElementById("sidarext-string-bundle");
  const listBox    = pageDocument.getElementById("sidarext-listbox");
  const selectedItem = listBox.selectedItem;

  // If an item is selected and the deletion is confirmed
  if(selectedItem && confirm(stringBundle.getString("sidarext_listDeleteConfirmation")))
  {
    listBox.removeChild(selectedItem);
  }
}

// Edits a list
function sidarext_editList()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const listBox    = pageDocument.getElementById("sidarext-listbox");
  const selectedItem = listBox.selectedItem;

  // If an option is selected
  if(selectedItem)
  {
    window.openDialog("chrome://sidarext/content/options/dialogs/list.xul", "sidarext-list-dialog", "centerscreen,chrome,modal", "edit", selectedItem.childNodes[0].getAttribute("label"), selectedItem.childNodes[1].getAttribute("label"), selectedItem.childNodes[2].getAttribute("label"));

    // If the description and url are set
    if(sidarext_listDescription && sidarext_listURL)
    {
      var listCell = pageDocument.createElement("listcell");

      sidarext_removeAllChildNodes(selectedItem);

      listCell.setAttribute("label", sidarext_listDescription);
      selectedItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", sidarext_listURL);
      listCell.setAttribute("crop", "end");
      selectedItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", sidarext_listKey);
      selectedItem.appendChild(listCell);
    }
  }
}


// Adds a resource
function sidarext_addResource()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const resourceBox    = pageDocument.getElementById("sidarext-listbox");

  window.openDialog("chrome://sidarext/content/options/dialogs/resource.xul", "sidarext-resource-dialog", "centerscreen,chrome,modal", "add");

  // If the description and URL are set
  if(sidarext_resourceDescription && sidarext_resourceURL)
  {
    var listCell = pageDocument.createElement("listcell");
    var listItem = pageDocument.createElement("listitem");

    listCell.setAttribute("label", sidarext_resourceDescription);
    listItem.appendChild(listCell);

    listCell = pageDocument.createElement("listcell");
    listCell.setAttribute("label", sidarext_resourceURL);
    listCell.setAttribute("crop", "end");
    listItem.appendChild(listCell);

    listCell = pageDocument.createElement("listcell");
    listCell.setAttribute("label", sidarext_resourceKey);
    listItem.appendChild(listCell);

    resourceBox.selectItem(resourceBox.appendChild(listItem));
  }
}

// Deletes a resource
function sidarext_deleteResource()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const stringBundle = document.getElementById("sidarext-string-bundle");
  const resourceBox    = pageDocument.getElementById("sidarext-listbox");
  const selectedItem = resourceBox.selectedItem;

  // If an item is selected and the deletion is confirmed
  if(selectedItem && confirm(stringBundle.getString("sidarext_resourceDeleteConfirmation")))
  {
    resourceBox.removeChild(selectedItem);
  }
}

// Edits a resource
function sidarext_editResource()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;
  const resourceBox    = pageDocument.getElementById("sidarext-listbox");
  const selectedItem = resourceBox.selectedItem;

  // If an option is selected
  if(selectedItem)
  {
    window.openDialog("chrome://sidarext/content/options/dialogs/resource.xul", "sidarext-resource-dialog", "centerscreen,chrome,modal", "edit", selectedItem.childNodes[0].getAttribute("label"), selectedItem.childNodes[1].getAttribute("label"), selectedItem.childNodes[2].getAttribute("label"));

    // If the description and url are set
    if(sidarext_resourceDescription && sidarext_resourceURL)
    {
      var listCell = pageDocument.createElement("listcell");

      sidarext_removeAllChildNodes(selectedItem);

      listCell.setAttribute("label", sidarext_resourceDescription);
      selectedItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", sidarext_resourceURL);
      listCell.setAttribute("crop", "end");
      selectedItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", sidarext_resourceKey);
      selectedItem.appendChild(listCell);
    }
  }
}


// Handles changing the options page
function sidarext_changePage(pageList)
{
  sidarext_storeOptions();

  document.getElementById("sidarext-options-iframe").setAttribute("src", pageList.selectedItem.value);
}


// Initializes the general page
function sidarext_initializeGeneral()
{
  const pageDocument     = document.getElementById("sidarext-options-iframe").contentDocument;
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

  // If the hide menu preference is set
  if(typeof sidarext_optionsDataBoolean["sidarext.options.general.menu.hide"] != "undefined")
  {
    pageDocument.getElementById("sidarext.options.general.menu.hide").checked = sidarext_optionsDataBoolean["sidarext.options.general.menu.hide"];
  }
  else if(preferencesService.prefHasUserValue("sidarext.options.general.menu.hide"))
  {
    pageDocument.getElementById("sidarext.options.general.menu.hide").checked = preferencesService.getBoolPref("sidarext.options.general.menu.hide");
  }
  else
  {
    pageDocument.getElementById("sidarext.options.general.menu.hide").checked = false;
  }

  // If the hide context menu preference is set
  if(typeof sidarext_optionsDataBoolean["sidarext.options.general.context.hide"] != "undefined")
  {
    pageDocument.getElementById("sidarext.options.general.context.hide").checked = sidarext_optionsDataBoolean["sidarext.options.general.context.hide"];
  }
  else if(preferencesService.prefHasUserValue("sidarext.options.general.context.hide"))
  {
    pageDocument.getElementById("sidarext.options.general.context.hide").checked = preferencesService.getBoolPref("sidarext.options.general.context.hide");
  }
  else
  {
    pageDocument.getElementById("sidarext.options.general.context.hide").checked = false;
  }

  // If the hide status bar preference is set
  if(typeof sidarext_optionsDataBoolean["sidarext.options.general.statusbar.hide"] != "undefined")
  {
    pageDocument.getElementById("sidarext.options.general.statusbar.hide").checked = sidarext_optionsDataBoolean["sidarext.options.general.statusbar.hide"];
  }
  else if(preferencesService.prefHasUserValue("sidarext.options.general.statusbar.hide"))
  {
    pageDocument.getElementById("sidarext.options.general.statusbar.hide").checked = preferencesService.getBoolPref("sidarext.options.general.statusbar.hide");
  }
  else
  {
    pageDocument.getElementById("sidarext.options.general.statusbar.hide").checked = false;
  }

  // If the language preference is set
  if (typeof sidarext_optionsDataString["sidarext.options.general.language"] != "undefined")
  {
    pageDocument.getElementById("sidarext.options.general.language").value = sidarext_optionsDataString["sidarext.options.general.language"];
  }
  else if (preferencesService.prefHasUserValue("sidarext.options.general.language"))
  {
    pageDocument.getElementById("sidarext.options.general.language").value = preferencesService.getComplexValue("sidarext.options.general.language", Components.interfaces.nsISupportsString).data.trim();
  }
  else
  {
    pageDocument.getElementById("sidarext.options.general.language").value = preferencesService.getCharPref("general.useragent.locale").substring(0, 2);
  }

  // If the open tabs preference is set
  if (typeof sidarext_optionsDataInteger["sidarext.options.tab.window"] != "undefined")
  {
    pageDocument.getElementById("sidarext.options.tab.window").selectedIndex = sidarext_optionsDataInteger["sidarext.options.tab.window"] - 1;
  }
  else if (preferencesService.prefHasUserValue("sidarext.options.tab.window"))
  {
    pageDocument.getElementById("sidarext.options.tab.window").selectedIndex = preferencesService.getIntPref("sidarext.options.tab.window") - 1;
  }
  else
  {
    pageDocument.getElementById("sidarext.options.tab.window").selectedIndex = 1;
  }

  // If the open tabs background preference is set
  if (typeof sidarext_optionsDataBoolean["sidarext.options.open.tab.background"] != "undefined")
  {
    pageDocument.getElementById("sidarext.options.open.tab.background").checked = sidarext_optionsDataBoolean["sidarext.options.open.tab.background"];
  }
  else if (preferencesService.prefHasUserValue("sidarext.options.open.tab.background"))
  {
    pageDocument.getElementById("sidarext.options.open.tab.background").checked = preferencesService.getBoolPref("sidarext.options.open.tab.background");
  }
  else
  {
    pageDocument.getElementById("sidarext.options.open.tab.background").checked = false;
  }

  pageDocument.getElementById("sidarext.options.open.tab.background").disabled = (pageDocument.getElementById("sidarext.options.tab.window").selectedIndex != 1);
}


// Initializes the options dialog
function sidarext_initializeOptions()
{
  const selectedPage = document.getElementById("sidarext-page-list").selectedItem.value;

  // If this is the general page
  if(selectedPage.indexOf("general") != -1)
  {
    sidarext_initializeGeneral();
  }
  else if(selectedPage.indexOf("blogs") != -1)
  {
    sidarext_initializeBlogs();
  }
  else if(selectedPage.indexOf("docs") != -1)
  {
    sidarext_initializeDocs();
  }
  else if(selectedPage.indexOf("lists") != -1)
  {
    sidarext_initializeLists();
  }
  else if(selectedPage.indexOf("tools") != -1)
  {
    sidarext_initializeTools();
  }
  else if(selectedPage.indexOf("resources") != -1)
  {
    sidarext_initializeResources();
  }
}


// Initializes the tools page
function sidarext_initializeTools()
{
  const pageDocument     = document.getElementById("sidarext-options-iframe").contentDocument;
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  const toolBox      = pageDocument.getElementById("sidarext-listbox");

  var description    = null;
  var descriptionValue = null;
  var key        = null;
  var keyValue     = null;
  var listCell     = null;
  var listItem     = null;
  var toolCount    = 0;
  var url        = null;
  var urlValue     = null;

  // If the tool count preference is set
  if(typeof sidarext_optionsDataInteger["sidarext.tool.count"] != "undefined")
  {
    toolCount = sidarext_optionsDataInteger["sidarext.tool.count"];
  }
  else if(preferencesService.prefHasUserValue("sidarext.tool.count"))
  {
    toolCount = preferencesService.getIntPref("sidarext.tool.count");
  }

  // Loop through the possible tools
  for(var i = 1; i <= toolCount; i++)
  {
    description = "sidarext.tool." + i + ".description";
    key     = "sidarext.tool." + i + ".key";
    url     = "sidarext.tool." + i + ".url";

    // If the description is set
    if(typeof sidarext_optionsDataString[description] != "undefined")
    {
      descriptionValue = sidarext_optionsDataString[description].trim();
    }
    else if(preferencesService.prefHasUserValue(description))
    {
      descriptionValue = preferencesService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      descriptionValue = null;
    }

    // If the key is set
    if(typeof sidarext_optionsDataString[key] != "undefined")
    {
      keyValue = sidarext_optionsDataString[key].trim();
    }
    else if(preferencesService.prefHasUserValue(key))
    {
      keyValue = preferencesService.getComplexValue(key, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      keyValue = null;
    }

    // If the URL is set
    if(typeof sidarext_optionsDataString[url] != "undefined")
    {
      urlValue = sidarext_optionsDataString[url].trim();
    }
    else if(preferencesService.prefHasUserValue(url))
    {
      urlValue = preferencesService.getComplexValue(url, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      urlValue = null;
    }

    // If the description and URL are set
    if(descriptionValue && urlValue)
    {
      listItem = pageDocument.createElement("listitem");

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", descriptionValue);
      listItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", urlValue);
      listCell.setAttribute("crop", "end");
      listItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");

      // If the key is set
      if(keyValue)
      {
        listCell.setAttribute("label", keyValue);
      }

      listItem.appendChild(listCell);

      toolBox.appendChild(listItem);
     }
  }
}

// Initializes the blogs page
function sidarext_initializeBlogs()
{
  const pageDocument     = document.getElementById("sidarext-options-iframe").contentDocument;
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  const blogBox      = pageDocument.getElementById("sidarext-listbox");

  var description    = null;
  var descriptionValue = null;
  var key        = null;
  var keyValue     = null;
  var listCell     = null;
  var listItem     = null;
  var blogCount    = 0;
  var url        = null;
  var urlValue     = null;

  // If the blog count preference is set
  if(typeof sidarext_optionsDataInteger["sidarext.blog.count"] != "undefined")
  {
    blogCount = sidarext_optionsDataInteger["sidarext.blog.count"];
  }
  else if(preferencesService.prefHasUserValue("sidarext.blog.count"))
  {
    blogCount = preferencesService.getIntPref("sidarext.blog.count");
  }

  // Loop through the possible blogs
  for(var i = 1; i <= blogCount; i++)
  {
    description = "sidarext.blog." + i + ".description";
    key     = "sidarext.blog." + i + ".key";
    url     = "sidarext.blog." + i + ".url";

    // If the description is set
    if(typeof sidarext_optionsDataString[description] != "undefined")
    {
      descriptionValue = sidarext_optionsDataString[description].trim();
    }
    else if(preferencesService.prefHasUserValue(description))
    {
      descriptionValue = preferencesService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      descriptionValue = null;
    }

    // If the key is set
    if(typeof sidarext_optionsDataString[key] != "undefined")
    {
      keyValue = sidarext_optionsDataString[key].trim();
    }
    else if(preferencesService.prefHasUserValue(key))
    {
      keyValue = preferencesService.getComplexValue(key, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      keyValue = null;
    }

    // If the URL is set
    if(typeof sidarext_optionsDataString[url] != "undefined")
    {
      urlValue = sidarext_optionsDataString[url].trim();
    }
    else if(preferencesService.prefHasUserValue(url))
    {
      urlValue = preferencesService.getComplexValue(url, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      urlValue = null;
    }

    // If the description and URL are set
    if(descriptionValue && urlValue)
    {
      listItem = pageDocument.createElement("listitem");

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", descriptionValue);
      listItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", urlValue);
      listCell.setAttribute("crop", "end");
      listItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");

      // If the key is set
      if(keyValue)
      {
        listCell.setAttribute("label", keyValue);
      }

      listItem.appendChild(listCell);

      blogBox.appendChild(listItem);
     }
  }
}


// Initializes the docs page
function sidarext_initializeDocs()
{
  const pageDocument     = document.getElementById("sidarext-options-iframe").contentDocument;
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  const docBox      = pageDocument.getElementById("sidarext-listbox");

  var description    = null;
  var descriptionValue = null;
  var key        = null;
  var keyValue     = null;
  var listCell     = null;
  var listItem     = null;
  var docCount    = 0;
  var url        = null;
  var urlValue     = null;

  // If the doc count preference is set
  if(typeof sidarext_optionsDataInteger["sidarext.document.count"] != "undefined")
  {
    docCount = sidarext_optionsDataInteger["sidarext.document.count"];
  }
  else if(preferencesService.prefHasUserValue("sidarext.document.count"))
  {
    docCount = preferencesService.getIntPref("sidarext.document.count");
  }

  // Loop through the possible docs
  for(var i = 1; i <= docCount; i++)
  {
    description = "sidarext.document." + i + ".description";
    key     = "sidarext.document." + i + ".key";
    url     = "sidarext.document." + i + ".url";

    // If the description is set
    if(typeof sidarext_optionsDataString[description] != "undefined")
    {
      descriptionValue = sidarext_optionsDataString[description].trim();
    }
    else if(preferencesService.prefHasUserValue(description))
    {
      descriptionValue = preferencesService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      descriptionValue = null;
    }

    // If the key is set
    if(typeof sidarext_optionsDataString[key] != "undefined")
    {
      keyValue = sidarext_optionsDataString[key].trim();
    }
    else if(preferencesService.prefHasUserValue(key))
    {
      keyValue = preferencesService.getComplexValue(key, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      keyValue = null;
    }

    // If the URL is set
    if(typeof sidarext_optionsDataString[url] != "undefined")
    {
      urlValue = sidarext_optionsDataString[url].trim();
    }
    else if(preferencesService.prefHasUserValue(url))
    {
      urlValue = preferencesService.getComplexValue(url, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      urlValue = null;
    }

    // If the description and URL are set
    if(descriptionValue && urlValue)
    {
      listItem = pageDocument.createElement("listitem");

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", descriptionValue);
      listItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", urlValue);
      listCell.setAttribute("crop", "end");
      listItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");

      // If the key is set
      if(keyValue)
      {
        listCell.setAttribute("label", keyValue);
      }

      listItem.appendChild(listCell);

      docBox.appendChild(listItem);
     }
  }
}


// Initializes the lists page
function sidarext_initializeLists()
{
  const pageDocument     = document.getElementById("sidarext-options-iframe").contentDocument;
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  const listBox      = pageDocument.getElementById("sidarext-listbox");

  var description    = null;
  var descriptionValue = null;
  var key        = null;
  var keyValue     = null;
  var listCell     = null;
  var listItem     = null;
  var listCount    = 0;
  var url        = null;
  var urlValue     = null;

  // If the list count preference is set
  if(typeof sidarext_optionsDataInteger["sidarext.list.count"] != "undefined")
  {
    listCount = sidarext_optionsDataInteger["sidarext.list.count"];
  }
  else if(preferencesService.prefHasUserValue("sidarext.list.count"))
  {
    listCount = preferencesService.getIntPref("sidarext.list.count");
  }

  // Loop through the possible lists
  for(var i = 1; i <= listCount; i++)
  {
    description = "sidarext.list." + i + ".description";
    key     = "sidarext.list." + i + ".key";
    url     = "sidarext.list." + i + ".url";

    // If the description is set
    if(typeof sidarext_optionsDataString[description] != "undefined")
    {
      descriptionValue = sidarext_optionsDataString[description].trim();
    }
    else if(preferencesService.prefHasUserValue(description))
    {
      descriptionValue = preferencesService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      descriptionValue = null;
    }

    // If the key is set
    if(typeof sidarext_optionsDataString[key] != "undefined")
    {
      keyValue = sidarext_optionsDataString[key].trim();
    }
    else if(preferencesService.prefHasUserValue(key))
    {
      keyValue = preferencesService.getComplexValue(key, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      keyValue = null;
    }

    // If the URL is set
    if(typeof sidarext_optionsDataString[url] != "undefined")
    {
      urlValue = sidarext_optionsDataString[url].trim();
    }
    else if(preferencesService.prefHasUserValue(url))
    {
      urlValue = preferencesService.getComplexValue(url, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      urlValue = null;
    }

    // If the description and URL are set
    if(descriptionValue && urlValue)
    {
      listItem = pageDocument.createElement("listitem");

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", descriptionValue);
      listItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", urlValue);
      listCell.setAttribute("crop", "end");
      listItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");

      // If the key is set
      if(keyValue)
      {
        listCell.setAttribute("label", keyValue);
      }

      listItem.appendChild(listCell);

      listBox.appendChild(listItem);
     }
  }
}


// Initializes the resources page
function sidarext_initializeResources()
{
  const pageDocument     = document.getElementById("sidarext-options-iframe").contentDocument;
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  const resourceBox      = pageDocument.getElementById("sidarext-listbox");

  var description    = null;
  var descriptionValue = null;
  var key        = null;
  var keyValue     = null;
  var listCell     = null;
  var listItem     = null;
  var resourceCount    = 0;
  var url        = null;
  var urlValue     = null;

  // If the resource count preference is set
  if(typeof sidarext_optionsDataInteger["sidarext.resource.count"] != "undefined")
  {
    resourceCount = sidarext_optionsDataInteger["sidarext.resource.count"];
  }
  else if(preferencesService.prefHasUserValue("sidarext.resource.count"))
  {
    resourceCount = preferencesService.getIntPref("sidarext.resource.count");
  }

  // Loop through the possible resources
  for(var i = 1; i <= resourceCount; i++)
  {
    description = "sidarext.resource." + i + ".description";
    key     = "sidarext.resource." + i + ".key";
    url     = "sidarext.resource." + i + ".url";

    // If the description is set
    if(typeof sidarext_optionsDataString[description] != "undefined")
    {
      descriptionValue = sidarext_optionsDataString[description].trim();
    }
    else if(preferencesService.prefHasUserValue(description))
    {
      descriptionValue = preferencesService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      descriptionValue = null;
    }

    // If the key is set
    if(typeof sidarext_optionsDataString[key] != "undefined")
    {
      keyValue = sidarext_optionsDataString[key].trim();
    }
    else if(preferencesService.prefHasUserValue(key))
    {
      keyValue = preferencesService.getComplexValue(key, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      keyValue = null;
    }

    // If the URL is set
    if(typeof sidarext_optionsDataString[url] != "undefined")
    {
      urlValue = sidarext_optionsDataString[url].trim();
    }
    else if(preferencesService.prefHasUserValue(url))
    {
      urlValue = preferencesService.getComplexValue(url, Components.interfaces.nsISupportsString).data.trim();
    }
    else
    {
      urlValue = null;
    }

    // If the description and URL are set
    if(descriptionValue && urlValue)
    {
      listItem = pageDocument.createElement("listitem");

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", descriptionValue);
      listItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");
      listCell.setAttribute("label", urlValue);
      listCell.setAttribute("crop", "end");
      listItem.appendChild(listCell);

      listCell = pageDocument.createElement("listcell");

      // If the key is set
      if(keyValue)
      {
        listCell.setAttribute("label", keyValue);
      }

      listItem.appendChild(listCell);

      resourceBox.appendChild(listItem);
     }
  }
}


// Moves the selected item down
function sidarext_moveDown()
{
  const pageDocument  = document.getElementById("sidarext-options-iframe").contentDocument;
  const resizeBox   = pageDocument.getElementById("sidarext-listbox");
  const resizeCount   = resizeBox.getRowCount();
  const selectedIndex = resizeBox.selectedIndex;
  const selectedItem  = resizeBox.selectedItem;

  // If an item is selected and it is not at the bottom
  if(selectedItem && selectedIndex != resizeCount - 1)
  {
    resizeBox.selectItem(resizeBox.insertBefore(selectedItem, resizeBox.getNextItem(selectedItem, 2)));
  }
}

// Moves the selected item up
function sidarext_moveUp()
{
  const pageDocument  = document.getElementById("sidarext-options-iframe").contentDocument;
  const resizeBox   = pageDocument.getElementById("sidarext-listbox");
  const selectedIndex = resizeBox.selectedIndex;
  const selectedItem  = resizeBox.selectedItem;

  // If an item is selected and it is not at the top
  if(selectedItem && selectedIndex != 0)
  {
    resizeBox.selectItem(resizeBox.insertBefore(selectedItem, resizeBox.getPreviousItem(selectedItem, 1)));
  }
}

// Resets the user's options
function sidarext_resetOptions()
{
  const stringBundle = document.getElementById("sidarext-string-bundle");

  // If the reset is confirmed
  if(confirm(stringBundle.getString("sidarext_resetConfirmation")))
  {
    const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    sidarext_localizedOptionsSetup = false;
    sidarext_optionsDataBoolean  = new Array();
    sidarext_optionsDataInteger  = new Array();
    sidarext_optionsDataString   = new Array();

    preferencesService.deleteBranch("sidarext.");

    sidarext_configureKeyboardShortcuts(true);
    sidarext_setupDefaultOptions();
    sidarext_setupLocalizedOptions();
    sidarext_initializeOptions();
  }
}

// Saves the user's options
function sidarext_saveOptions()
{
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
  const string       = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);

  var parentWindow = null;
  var option     = null;
  var optionValue  = null;

  // Make sure current page is stored
  sidarext_storeOptions();

  // Loop through the boolean options
  for(option in sidarext_optionsDataBoolean)
  {
    preferencesService.setBoolPref(option, sidarext_optionsDataBoolean[option]);
  }

  // Loop through the integer options
  for(option in sidarext_optionsDataInteger)
  {
    optionValue = sidarext_optionsDataInteger[option];

    // If the option value is set
    if(optionValue)
    {
      preferencesService.setIntPref(option, optionValue);
    }
    else if(preferencesService.prefHasUserValue(option))
    {
      preferencesService.clearUserPref(option);
    }
  }

  // Loop through the string options
  for(option in sidarext_optionsDataString)
  {
    optionValue = sidarext_optionsDataString[option];

    // If the option value is set or the preference currently has a value
    if(optionValue || preferencesService.prefHasUserValue(option))
    {
      string.data = optionValue;

      preferencesService.setComplexValue(option, Components.interfaces.nsISupportsString, string);
    }
  }
}

// Stores the user's options to be saved later
function sidarext_storeOptions()
{
  const iFrame       = document.getElementById("sidarext-options-iframe");
  const iFrameSrc      = iFrame.getAttribute("src");
  const pageDocument     = iFrame.contentDocument;
  const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

  var childNodes  = null;
  var description = null;
  var i       = 0;
  var listItem  = null;
  var key     = null;
  var url     = null;

  // If this is the general
  if(iFrameSrc.indexOf("general") != -1)
  {
    sidarext_optionsDataBoolean["sidarext.options.general.context.hide"]  = pageDocument.getElementById("sidarext.options.general.context.hide").checked;
    sidarext_optionsDataBoolean["sidarext.options.general.menu.hide"]     = pageDocument.getElementById("sidarext.options.general.menu.hide").checked;
    sidarext_optionsDataBoolean["sidarext.options.general.statusbar.hide"]  = pageDocument.getElementById("sidarext.options.general.statusbar.hide").checked;
    sidarext_optionsDataString["sidarext.options.general.language"]     = pageDocument.getElementById("sidarext.options.general.language").value;
    sidarext_optionsDataInteger["sidarext.options.tab.window"]        = pageDocument.getElementById("sidarext.options.tab.window").selectedIndex + 1;
    sidarext_optionsDataBoolean["sidarext.options.open.tab.background"]   = pageDocument.getElementById("sidarext.options.open.tab.background").checked;
  }
  else if(iFrameSrc.indexOf("tools") != -1)
  {
    const toolBox = pageDocument.getElementById("sidarext-listbox");
    var toolCount = 0;

    // If the tool count preference is set
    if(preferencesService.prefHasUserValue("sidarext.tool.count"))
    {
      toolCount = preferencesService.getIntPref("sidarext.tool.count");
    }

    // Loop through the previous tools
    for(i = 1; i <= toolCount; i++)
    {
      description = "sidarext.tool." + i + ".description";
      key     = "sidarext.tool." + i + ".key";
      url     = "sidarext.tool." + i + ".url";

      sidarext_optionsDataString[description] = "";
      sidarext_optionsDataString[key]     = "";
      sidarext_optionsDataString[url]     = "";
    }

    toolCount = toolBox.getRowCount();

    // Loop through the possible tools
    for(i = 1; i <= toolCount; i++)
    {
      description = "sidarext.tool." + i + ".description";
      listItem  = toolBox.getItemAtIndex(i - 1);
      childNodes  = listItem.childNodes;
      key     = "sidarext.tool." + i + ".key";
      url     = "sidarext.tool." + i + ".url";

      sidarext_optionsDataString[description] = listItem.childNodes[0].getAttribute("label").trim();
      sidarext_optionsDataString[key]     = listItem.childNodes[2].getAttribute("label").trim();
      sidarext_optionsDataString[url]     = listItem.childNodes[1].getAttribute("label").trim();
    }

    sidarext_optionsDataInteger["sidarext.tool.count"] = toolCount;
  }
  else if(iFrameSrc.indexOf("blogs") != -1)
  {
    const blogBox = pageDocument.getElementById("sidarext-listbox");
    var blogCount = 0;

    // If the blog count preference is set
    if(preferencesService.prefHasUserValue("sidarext.blog.count"))
    {
      blogCount = preferencesService.getIntPref("sidarext.blog.count");
    }

    // Loop through the previous blogs
    for(i = 1; i <= blogCount; i++)
    {
      description = "sidarext.blog." + i + ".description";
      key     = "sidarext.blog." + i + ".key";
      url     = "sidarext.blog." + i + ".url";

      sidarext_optionsDataString[description] = "";
      sidarext_optionsDataString[key]     = "";
      sidarext_optionsDataString[url]     = "";
    }

    blogCount = blogBox.getRowCount();

    // Loop through the possible blogs
    for(i = 1; i <= blogCount; i++)
    {
      description = "sidarext.blog." + i + ".description";
      listItem  = blogBox.getItemAtIndex(i - 1);
      childNodes  = listItem.childNodes;
      key     = "sidarext.blog." + i + ".key";
      url     = "sidarext.blog." + i + ".url";

      sidarext_optionsDataString[description] = listItem.childNodes[0].getAttribute("label").trim();
      sidarext_optionsDataString[key]     = listItem.childNodes[2].getAttribute("label").trim();
      sidarext_optionsDataString[url]     = listItem.childNodes[1].getAttribute("label").trim();
    }

    sidarext_optionsDataInteger["sidarext.blog.count"] = blogCount;
  }
  else if(iFrameSrc.indexOf("docs") != -1)
  {
    const docBox = pageDocument.getElementById("sidarext-listbox");
    var docCount = 0;

    // If the doc count preference is set
    if(preferencesService.prefHasUserValue("sidarext.document.count"))
    {
      docCount = preferencesService.getIntPref("sidarext.document.count");
    }

    // Loop through the previous docs
    for(i = 1; i <= docCount; i++)
    {
      description = "sidarext.document." + i + ".description";
      key     = "sidarext.document." + i + ".key";
      url     = "sidarext.document." + i + ".url";

      sidarext_optionsDataString[description] = "";
      sidarext_optionsDataString[key]     = "";
      sidarext_optionsDataString[url]     = "";
    }

    docCount = docBox.getRowCount();

    // Loop through the possible docs
    for(i = 1; i <= docCount; i++)
    {
      description = "sidarext.document." + i + ".description";
      listItem  = docBox.getItemAtIndex(i - 1);
      childNodes  = listItem.childNodes;
      key     = "sidarext.document." + i + ".key";
      url     = "sidarext.document." + i + ".url";

      sidarext_optionsDataString[description] = listItem.childNodes[0].getAttribute("label").trim();
      sidarext_optionsDataString[key]     = listItem.childNodes[2].getAttribute("label").trim();
      sidarext_optionsDataString[url]     = listItem.childNodes[1].getAttribute("label").trim();
    }

    sidarext_optionsDataInteger["sidarext.document.count"] = docCount;
  }
  else if(iFrameSrc.indexOf("lists") != -1)
  {
    const listBox = pageDocument.getElementById("sidarext-listbox");
    var listCount = 0;

    // If the list count preference is set
    if(preferencesService.prefHasUserValue("sidarext.list.count"))
    {
      listCount = preferencesService.getIntPref("sidarext.list.count");
    }

    // Loop through the previous lists
    for(i = 1; i <= listCount; i++)
    {
      description = "sidarext.list." + i + ".description";
      key     = "sidarext.list." + i + ".key";
      url     = "sidarext.list." + i + ".url";

      sidarext_optionsDataString[description] = "";
      sidarext_optionsDataString[key]     = "";
      sidarext_optionsDataString[url]     = "";
    }

    listCount = listBox.getRowCount();

    // Loop through the possible lists
    for(i = 1; i <= listCount; i++)
    {
      description = "sidarext.list." + i + ".description";
      listItem  = listBox.getItemAtIndex(i - 1);
      childNodes  = listItem.childNodes;
      key     = "sidarext.list." + i + ".key";
      url     = "sidarext.list." + i + ".url";

      sidarext_optionsDataString[description] = listItem.childNodes[0].getAttribute("label").trim();
      sidarext_optionsDataString[key]     = listItem.childNodes[2].getAttribute("label").trim();
      sidarext_optionsDataString[url]     = listItem.childNodes[1].getAttribute("label").trim();
    }

    sidarext_optionsDataInteger["sidarext.list.count"] = listCount;
  }
  else if(iFrameSrc.indexOf("resources") != -1)
  {
    const resourceBox = pageDocument.getElementById("sidarext-listbox");
    var resourceCount = 0;

    // If the resource count preference is set
    if(preferencesService.prefHasUserValue("sidarext.resource.count"))
    {
      resourceCount = preferencesService.getIntPref("sidarext.resource.count");
    }

    // Loop through the previous resources
    for(i = 1; i <= resourceCount; i++)
    {
      description = "sidarext.resource." + i + ".description";
      key     = "sidarext.resource." + i + ".key";
      url     = "sidarext.resource." + i + ".url";

      sidarext_optionsDataString[description] = "";
      sidarext_optionsDataString[key]     = "";
      sidarext_optionsDataString[url]     = "";
    }

    resourceCount = resourceBox.getRowCount();

    // Loop through the possible resources
    for(i = 1; i <= resourceCount; i++)
    {
      description = "sidarext.resource." + i + ".description";
      listItem  = resourceBox.getItemAtIndex(i - 1);
      childNodes  = listItem.childNodes;
      key     = "sidarext.resource." + i + ".key";
      url     = "sidarext.resource." + i + ".url";

      sidarext_optionsDataString[description] = listItem.childNodes[0].getAttribute("label").trim();
      sidarext_optionsDataString[key]     = listItem.childNodes[2].getAttribute("label").trim();
      sidarext_optionsDataString[url]     = listItem.childNodes[1].getAttribute("label").trim();
    }

    sidarext_optionsDataInteger["sidarext.resource.count"] = resourceCount;
  }
}

// Updates the tab option status
function sidarext_updateTabOptionStatus()
{
  const pageDocument = document.getElementById("sidarext-options-iframe").contentDocument;

  var disabled = false;

  // If open tabs is checked
  if (pageDocument.getElementById("sidarext.options.tab.window").selectedIndex != 1)
  {
    disabled = true;
  }

  pageDocument.getElementById("sidarext.options.open.tab.background").disabled = disabled;
}
